*******************************************************************************
*** Do file to run all of the programs to generate substantive effects for the Whitten and Williams "Don't Stand So Close to Me" project.
***
*** Created: 3-13-14
***
*** NOTE: make sure that you run this do file before trying to run the "Whitten and Williams AJPS--Replication.do" file!
*******************************************************************************

*******************************************************************************
*** Another program to speed up the calculation of marginal effects: high clarity
cap program drop me_sarh
program define me_sarh

	mat b = e(b)
	mat V = e(V)
	
	local c: colnames b
	local cno = colsof(b)
	
	local k = e(rank)
	foreach i of numlist 1(1)`k' {
		scalar b`i' = b[1,`i']
		scalar varb`i' = V[`i',`i']
		foreach x of numlist 1(1)`k' {
			scalar covb`i'b`x' = V[`i',`x']
		}
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'
		if "`v'" == "ciep_perc" {
			local cp = `i'
		}
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'
		if "`v'" == "rgdppc_growth" {
			local g = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "growth_govt" {
			local gg = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "pm_growth" {
			local pmg = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "govt_ciep" {
			local gc = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "pm_ciep" {
			local pmc = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "gparties" {
			local gp = `i'
		}	
	}	
	
	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "lag_pervote" {
			local pv = `i'
		}	
	}
	
	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "pm_gparties" {
			local pmgp = `i'
		}	
	}	

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "pm_lag_pervote" {
			local pmv = `i'
		}	
	}	
	
	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "niche_lag_pervote" {
			local nv = `i'
		}	
	}	
	
	scalar me_o = round(b`g', .001)
	scalar me_g = round(b`g' + (1*b`gg'), .001)
	scalar me_pm = round(b`g' + (1*b`pmg'), .001)

	scalar se_o = round(sqrt(varb`g'), .001)
	scalar se_g = round(sqrt(varb`g' + ((1^2)*varb`gg') + (2*1*covb`g'b`gg')), .001)
	scalar se_pm = round(sqrt(varb`g' + ((1^2)*varb`pmg') + (2*1*covb`g'b`pmg')), .001)

	di _newline(2)
	di as result "Marginal effect of GDP for Opposition = " me_o
	di as result "90% CI for marginal effect for opposition = [" me_o - (1.65*se_o) ", "  me_o + (1.65*se_o) "]"
	di as result "95% CI for marginal effect for opposition = [" me_o - (1.96*se_o) ", "  me_o + (1.96*se_o) "]"
	di _newline(1)
	di as result "Marginal effect of GDP for Government (Non-PM) = " me_g
	di as result "90% CI for marginal effect for government (Non-PM) = [" me_g - (1.65*se_g) ", "  me_g + (1.65*se_g) "]"
	di as result "95% CI for marginal effect for government (Non-PM) = [" me_g - (1.96*se_g) ", "  me_g + (1.96*se_g) "]"
	di _newline(1)
	di as result "Marginal effect of GDP for PM = " me_pm
	di as result "90% CI for marginal effect for PM = [" me_pm - (1.65*se_pm) ", "  me_pm + (1.65*se_pm) "]"
	di as result "95% CI for marginal effect for PM = [" me_pm - (1.96*se_pm) ", "  me_pm + (1.96*se_pm) "]"

	* ME for Opposition = Government
	test growth_govt = 0

	* ME for Opposition = PM
	test pm_growth = 0
	
	* ME for Government = PM
	test growth_govt = pm_growth 

	scalar ciep_o = round(b`cp', .001)
	scalar ciep_g = round(b`cp' + (b`gc'*1), .001)
	scalar ciep_pm = round(b`cp' + (b`pmc'*1), .001)

	scalar se_ciep_o = round(sqrt(varb`cp'), .001)
	scalar se_ciep_g = round(sqrt(varb`cp' + ((1^2)*varb`gc') + ((2*1)*covb`cp'b`gc')), .001)
	scalar se_ciep_pm = round(sqrt(varb`cp' + ((1^2)*varb`pmc') + ((2*1)*covb`cp'b`pmc')), .001)

	di _newline(2)
	di as result "Marginal effect of CIEP for Opposition = " ciep_o
	di as result "90% CI for marginal effect for opposition = [" ciep_o - (1.65*se_ciep_o) ", "  ciep_o + (1.65*se_ciep_o) "]"
	di as result "95% CI for marginal effect for opposition = [" ciep_o - (1.96*se_ciep_o) ", "  ciep_o + (1.96*se_ciep_o) "]"
	di _newline(1)
	di as result "Marginal effect of CIEP for Government (non-PM) = " ciep_g
	di as result "90% CI for marginal effect for government (non-PM) = [" ciep_g - (1.65*se_ciep_g) ", "  ciep_g + (1.65*se_ciep_g) "]"
	di as result "95% CI for marginal effect for government (non-PM) = [" ciep_g - (1.96*se_ciep_g) ", "  ciep_g + (1.96*se_ciep_g) "]"
	di _newline(1)
	di as result "Marginal effect of CIEP for PM = " ciep_pm
	di as result "90% CI for marginal effect for PM = [" ciep_pm - (1.65*se_ciep_pm) ", "  ciep_pm + (1.65*se_ciep_pm) "]"
	di as result "95% CI for marginal effect for PM = [" ciep_pm - (1.96*se_ciep_pm) ", "  ciep_pm + (1.96*se_ciep_pm) "]"

	* ME for Opposition = Government
	test govt_ciep = 0

	* ME for Opposition = PM
	test pm_ciep = 0
	
	* ME for Government = PM
	test govt_ciep = pm_ciep
	
	scalar gp_o = round(b`gp', .001)
	scalar gp_pm = round(b`gp' + (b`pmgp'*1), .001)

	scalar se_gp_o = round(sqrt(varb`gp'), .001)
	scalar se_gp_pm = round(sqrt(varb`gp' + ((1^2)*varb`pmgp') + ((2*1)*covb`gp'b`pmgp')), .001)

	di _newline(2)
	di as result "Marginal effect of Gov't Parties for Opposition = " gp_o
	di as result "90% CI for marginal effect for opposition = [" gp_o - (1.65*se_gp_o) ", "  gp_o + (1.65*se_gp_o) "]"
	di as result "95% CI for marginal effect for opposition = [" gp_o - (1.96*se_gp_o) ", "  gp_o + (1.96*se_gp_o) "]"
	di _newline(1)
	di as result "Marginal effect of Gov't Parties for PM = " gp_pm
	di as result "90% CI for marginal effect for PM = [" gp_pm - (1.65*se_gp_pm) ", "  gp_pm + (1.65*se_gp_pm) "]"
	di as result "95% CI for marginal effect for PM = [" gp_pm - (1.96*se_gp_pm) ", "  gp_pm + (1.96*se_gp_pm) "]"

	* ME for Opposition = PM
	test pm_gparties = 0	
	
	scalar v_o = round(b`pv', .001)
	scalar v_n = round(b`pv' + (b`nv'*1), .001)
	scalar v_pm = round(b`pv' + (b`pmv'*1), .001)

	scalar se_v_o = round(sqrt(varb`pv'), .001)
	scalar se_v_n = round(sqrt(varb`pv' + ((1^2)*varb`nv') + ((2*1)*covb`pv'b`nv')), .001)
	scalar se_v_pm = round(sqrt(varb`pv' + ((1^2)*varb`pmv') + ((2*1)*covb`pv'b`pmv')), .001)

	di _newline(2)
	di as result "Marginal effect of Previous Vote for Non-Niche Opposition = " v_o
	di as result "90% CI for marginal effect for non-niche opposition = [" v_o - (1.65*se_v_o) ", "  v_o + (1.65*se_v_o) "]"
	di as result "95% CI for marginal effect for non-niche opposition = [" v_o - (1.96*se_v_o) ", "  v_o + (1.96*se_v_o) "]"
	di _newline(1)
	di as result "Marginal effect of Previous vote for PM = " v_pm
	di as result "90% CI for marginal effect for PM = [" v_pm - (1.65*se_v_pm) ", "  v_pm + (1.65*se_v_pm) "]"
	di as result "95% CI for marginal effect for PM = [" v_pm - (1.96*se_v_pm) ", "  v_pm + (1.96*se_v_pm) "]"
	di _newline(1)
	di as result "Marginal effect of Previous vote for niche = " v_n
	di as result "90% CI for marginal effect for niche = [" v_n - (1.65*se_v_n) ", "  v_n + (1.65*se_v_n) "]"
	di as result "95% CI for marginal effect for niche = [" v_n - (1.96*se_v_n) ", "  v_n + (1.96*se_v_n) "]"
	
	* ME for Non-niche opposition = PM
	test pm_lag_pervote = 0		
	
	* ME for Opposition = Niche
	test niche_lag_pervote = 0
	
end



*******************************************************************************
*** Another program to speed up the calculation of marginal effects: low clarity
cap program drop me_sarl
program define me_sarl

	mat b = e(b)
	mat V = e(V)
	
	local c: colnames b
	local cno = colsof(b)
	
	local k = e(rank)
	foreach i of numlist 1(1)`k' {
		scalar b`i' = b[1,`i']
		scalar varb`i' = V[`i',`i']
		foreach x of numlist 1(1)`k' {
			scalar covb`i'b`x' = V[`i',`x']
		}
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'
		if "`v'" == "ciep_perc" {
			local cp = `i'
		}
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'
		if "`v'" == "rgdppc_growth" {
			local g = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "growth_govt" {
			local gg = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "pm_growth" {
			local pmg = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "govt_ciep" {
			local gc = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "pm_ciep" {
			local pmc = `i'
		}	
	}

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "majority" {
			local maj = `i'
		}	
	}
	
	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "gparties" {
			local gp = `i'
		}	
	}	
	
	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "lag_pervote" {
			local pv = `i'
		}	
	}
	
	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "pm_majority" {
			local pmm = `i'
		}	
	}	
	
	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "pm_gparties" {
			local pmgp = `i'
		}	
	}	

	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "pm_lag_pervote" {
			local pmv = `i'
		}	
	}	
	
	foreach i of numlist 1(1)`cno' {
		local v: word `i' of `c'	
		if "`v'" == "niche_lag_pervote" {
			local nv = `i'
		}	
	}	
	
	scalar me_o = round(b`g', .001)
	scalar me_g = round(b`g' + (1*b`gg'), .001)
	scalar me_pm = round(b`g' + (1*b`pmg'), .001)

	scalar se_o = round(sqrt(varb`g'), .001)
	scalar se_g = round(sqrt(varb`g' + ((1^2)*varb`gg') + (2*1*covb`g'b`gg')), .001)
	scalar se_pm = round(sqrt(varb`g' + ((1^2)*varb`pmg') + (2*1*covb`g'b`pmg')), .001)

	di _newline(2)
	di as result "Marginal effect of GDP for Opposition = " me_o
	di as result "90% CI for marginal effect for opposition = [" me_o - (1.65*se_o) ", "  me_o + (1.65*se_o) "]"
	di as result "95% CI for marginal effect for opposition = [" me_o - (1.96*se_o) ", "  me_o + (1.96*se_o) "]"
	di _newline(1)
	di as result "Marginal effect of GDP for Government (Non-PM) = " me_g
	di as result "90% CI for marginal effect for government (Non-PM) = [" me_g - (1.65*se_g) ", "  me_g + (1.65*se_g) "]"
	di as result "95% CI for marginal effect for government (Non-PM) = [" me_g - (1.96*se_g) ", "  me_g + (1.96*se_g) "]"
	di _newline(1)
	di as result "Marginal effect of GDP for PM = " me_pm
	di as result "90% CI for marginal effect for PM = [" me_pm - (1.65*se_pm) ", "  me_pm + (1.65*se_pm) "]"
	di as result "95% CI for marginal effect for PM = [" me_pm - (1.96*se_pm) ", "  me_pm + (1.96*se_pm) "]"

	* ME for Opposition = Government
	test growth_govt = 0

	* ME for Opposition = PM
	test pm_growth = 0
	
	* ME for Government = PM
	test growth_govt = pm_growth 

	scalar ciep_o = round(b`cp', .001)
	scalar ciep_g = round(b`cp' + (b`gc'*1), .001)
	scalar ciep_pm = round(b`cp' + (b`pmc'*1), .001)

	scalar se_ciep_o = round(sqrt(varb`cp'), .001)
	scalar se_ciep_g = round(sqrt(varb`cp' + ((1^2)*varb`gc') + ((2*1)*covb`cp'b`gc')), .001)
	scalar se_ciep_pm = round(sqrt(varb`cp' + ((1^2)*varb`pmc') + ((2*1)*covb`cp'b`pmc')), .001)

	di _newline(2)
	di as result "Marginal effect of CIEP for Opposition = " ciep_o
	di as result "90% CI for marginal effect for opposition = [" ciep_o - (1.65*se_ciep_o) ", "  ciep_o + (1.65*se_ciep_o) "]"
	di as result "95% CI for marginal effect for opposition = [" ciep_o - (1.96*se_ciep_o) ", "  ciep_o + (1.96*se_ciep_o) "]"
	di _newline(1)
	di as result "Marginal effect of CIEP for Government (non-PM) = " ciep_g
	di as result "90% CI for marginal effect for government (non-PM) = [" ciep_g - (1.65*se_ciep_g) ", "  ciep_g + (1.65*se_ciep_g) "]"
	di as result "95% CI for marginal effect for government (non-PM) = [" ciep_g - (1.96*se_ciep_g) ", "  ciep_g + (1.96*se_ciep_g) "]"
	di _newline(1)
	di as result "Marginal effect of CIEP for PM = " ciep_pm
	di as result "90% CI for marginal effect for PM = [" ciep_pm - (1.65*se_ciep_pm) ", "  ciep_pm + (1.65*se_ciep_pm) "]"
	di as result "95% CI for marginal effect for PM = [" ciep_pm - (1.96*se_ciep_pm) ", "  ciep_pm + (1.96*se_ciep_pm) "]"

	* ME for Opposition = Government
	test govt_ciep = 0

	* ME for Opposition = PM
	test pm_ciep = 0
	
	* ME for Government = PM
	test govt_ciep = pm_ciep
	
	scalar maj_o = round(b`maj', .001)
	scalar maj_pm = round(b`maj' + (b`pmm'*1), .001)

	scalar se_maj_o = round(sqrt(varb`maj'), .001)
	scalar se_maj_pm = round(sqrt(varb`maj' + ((1^2)*varb`pmm') + ((2*1)*covb`maj'b`pmm')), .001)

	di _newline(2)
	di as result "Marginal effect of Majority for Opposition = " maj_o
	di as result "90% CI for marginal effect for opposition = [" maj_o - (1.65*se_maj_o) ", "  maj_o + (1.65*se_maj_o) "]"
	di as result "95% CI for marginal effect for opposition = [" maj_o - (1.96*se_maj_o) ", "  maj_o + (1.96*se_maj_o) "]"
	di _newline(1)
	di as result "Marginal effect of Majority for PM = " maj_pm
	di as result "90% CI for marginal effect for PM = [" maj_pm - (1.65*se_maj_pm) ", "  maj_pm + (1.65*se_maj_pm) "]"
	di as result "95% CI for marginal effect for PM = [" maj_pm - (1.96*se_maj_pm) ", "  maj_pm + (1.96*se_maj_pm) "]"

	* ME for Opposition = PM
	test pm_majority = 0

	scalar gp_o = round(b`gp', .001)
	scalar gp_pm = round(b`gp' + (b`pmgp'*1), .001)

	scalar se_gp_o = round(sqrt(varb`gp'), .001)
	scalar se_gp_pm = round(sqrt(varb`gp' + ((1^2)*varb`pmgp') + ((2*1)*covb`gp'b`pmgp')), .001)

	di _newline(2)
	di as result "Marginal effect of Gov't Parties for Opposition = " gp_o
	di as result "90% CI for marginal effect for opposition = [" gp_o - (1.65*se_gp_o) ", "  gp_o + (1.65*se_gp_o) "]"
	di as result "95% CI for marginal effect for opposition = [" gp_o - (1.96*se_gp_o) ", "  gp_o + (1.96*se_gp_o) "]"
	di _newline(1)
	di as result "Marginal effect of Gov't Parties for PM = " gp_pm
	di as result "90% CI for marginal effect for PM = [" gp_pm - (1.65*se_gp_pm) ", "  gp_pm + (1.65*se_gp_pm) "]"
	di as result "95% CI for marginal effect for PM = [" gp_pm - (1.96*se_gp_pm) ", "  gp_pm + (1.96*se_gp_pm) "]"

	* ME for Opposition = PM
	test pm_gparties = 0	
	
	scalar v_o = round(b`pv', .001)
	scalar v_n = round(b`pv' + (b`nv'*1), .001)
	scalar v_pm = round(b`pv' + (b`pmv'*1), .001)

	scalar se_v_o = round(sqrt(varb`pv'), .001)
	scalar se_v_n = round(sqrt(varb`pv' + ((1^2)*varb`nv') + ((2*1)*covb`pv'b`nv')), .001)
	scalar se_v_pm = round(sqrt(varb`pv' + ((1^2)*varb`pmv') + ((2*1)*covb`pv'b`pmv')), .001)

	di _newline(2)
	di as result "Marginal effect of Previous Vote for Non-Niche Opposition = " v_o
	di as result "90% CI for marginal effect for non-niche opposition = [" v_o - (1.65*se_v_o) ", "  v_o + (1.65*se_v_o) "]"
	di as result "95% CI for marginal effect for non-niche opposition = [" v_o - (1.96*se_v_o) ", "  v_o + (1.96*se_v_o) "]"
	di _newline(1)
	di as result "Marginal effect of Previous vote for PM = " v_pm
	di as result "90% CI for marginal effect for PM = [" v_pm - (1.65*se_v_pm) ", "  v_pm + (1.65*se_v_pm) "]"
	di as result "95% CI for marginal effect for PM = [" v_pm - (1.96*se_v_pm) ", "  v_pm + (1.96*se_v_pm) "]"
	di _newline(1)
	di as result "Marginal effect of Previous vote for niche = " v_n
	di as result "90% CI for marginal effect for niche = [" v_n - (1.65*se_v_n) ", "  v_n + (1.65*se_v_n) "]"
	di as result "95% CI for marginal effect for niche = [" v_n - (1.96*se_v_n) ", "  v_n + (1.96*se_v_n) "]"
	
	* ME for Non-niche opposition = PM
	test pm_lag_pervote = 0		
	
	* ME for Opposition = Niche
	test niche_lag_pervote = 0
end

*******************************************************************************
******* Program to get appropriate betas and s.e.s for marginal effects: for spatreg
capture program drop get_me
program define get_me
	mat b = e(b)
	mat V = e(V)

	local k = e(rank0)
	foreach i of numlist 1(1)`k' {
		scalar b`i' = b[1,`i']
		scalar varb`i' = V[`i',`i']
		foreach x of numlist 1(1)`k' {
			scalar covb`i'b`x' = V[`i',`x']
		}
	}
end

*******************************************************************************
*** Program to draw from posterior distribution for uncertainty
capture program drop draws
program define draws
syntax, d(real) name(string)
	mat b =e(b)
	mat V = e(V)
	local RN : rownames(V)

	local a = 1
	foreach i in `RN' {
		if "`i'" == "_cons" {
			local newlist "`newlist' draw_`a'_`i'"
			local a = `a' + 1
		}
		else {
			local newlist "`newlist' draw_`i'"
		}
	}
	preserve
		corr2data "`newlist'", n(`d') means(b) cov(V) clear
		outsheet `newlist' using "`name'.csv", comma replace
	restore
end

*******************************************************************************
*** Program to generate fit statistics for the SAR
capture program drop sr_fit
program define sr_fit
syntax, dv(string) rhs(string) w(string)
	preserve

	matrix y_hat = e(yhat)
	svmat y_hat
	rename y_hat1 y_hat

	* Calculate the measures of fit.
	qui sum `dv', meanonly
	scalar y_mean = r(mean)	
	gen mu_hat = (`dv' - y_hat)^2
	gen num = (y_hat - y_mean)^2
	gen denom = (`dv' - y_mean)^2
	collapse (sum) ess = num tss = denom rss = mu_hat
	gen r2 = ess/tss
	gen rmse = sqrt(rss/e(N))
	local p = e(k) - e(df_m)
	gen adj_r2 = 1-(1-r2)*((e(N)-1)/(e(N)-`p'-1))
	qui sum r2, meanonly
	di as result "R Squared =  " r(mean)
	di 
	qui sum adj_r2, meanonly
	di as result "Adjusted R Squared =  " r(mean)
	di 
	qui sum rmse, meanonly
	di as result "Root MSE = " r(mean)

	* AIC and BIC
	local ll = e(ll)
	local p = e(rank0) + e(k_eq_model)
	local N = e(N)
	local aic = (-2 * `ll') + (2 * `p')
	local bic = (-2 * `ll') + (`p' * ln(`N'))
	di as result "AIC =  "  `aic'
	di as result "BIC =  " `bic'
	capture drop cons y_hat1 mu_hat num denom r2 rmse adj_r2 
	restore
end

*******************************************************************************
*** Program to display fit statistics for non-spatial OLS
capture program drop ols_ar2
program define ols_ar2
	local ar2 = 1-(1-e(r2))*((e(N)-1)/(e(N)-e(df_m)-1))
	di as result "Adjusted R Squared =  "  `ar2'
	di as result "Root Mean Squared Error = " e(rmse)
	qui estat ic
	mat S = r(S)
	local aic = S[1,5]
	local bic = S[1,6]
	di as result "AIC = " `aic'
	di as result "BIC = " `bic'	
end
